package com.yeejoin.amos.boot.module.tdc.api.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.yeejoin.amos.boot.biz.common.entity.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.Date;

/**
 * @author xxz
 */
@Data
@Accessors(chain = true)
@TableName("tdc_model")
@ApiModel(value="CheckModel对象", description="校验模型表")
public class CheckModel {
    private static final long serialVersionUID = 1L;

    @TableId(value = "sequence_nbr", type = IdType.ID_WORKER)
    protected Long sequenceNbr;

    @ApiModelProperty(value = "模型名称")
    private String modelName;

    @ApiModelProperty(value = "机构code")
    private String amosOrgCode;

    @ApiModelProperty(value = "机构名称")
    private String amosOrgName;

    @ApiModelProperty(value = "指标表名")
    private String idxTableName;

    @ApiModelProperty(value = "校验状态")
    private int checkStatus;

    @ApiModelProperty(value = "校验时间")
    private Date checkDate;

    @ApiModelProperty(value = "模型图片地址")
    private String modelPictureUrl;

    @ApiModelProperty(value = "模型规则知识包")
    private String modelRule;

    @ApiModelProperty(value = "指标模型所属项目id")
    private String projectId;

    @ApiModelProperty(value = "指标模型表id")
    private String tableId;

    @ApiModelProperty(value = "模型校验项数量")
    private int checkItemAmount;

    @ApiModelProperty(value = "模型文件地址")
    private String ModelFile;

}
